# -*- perl -*-

# Copyright (c) 2002 by Jeff Weisberg
# Author: Jeff Weisberg <argus @ tcp4me.com>
# Date: 2002-Apr-02 15:03 (EST)
# Function: implement some of the control channel commands
#
# $Id: Commands.pm,v 1.15 2002/12/25 21:42:21 jaw Exp $

package Control;

# And a fair, saintly Lady called to me
# In such wise, I besought her to command me.
#   -- Dante, Divine Comedy

sub cmd_echo {
    my $ctl = shift;
    my $param = shift;
    my ($k, $v );

    $ctl->ok();
    foreach $k (keys %$param ){
	$ctl->write( "$k: $param->{$k}\n" );
    }
    $ctl->write("\n");
}

sub cmd_byebye {
    my $ctl = shift;

    $ctl->ok();
    $ctl->write( "$IDWORD 200 bye bye\n\n" );
    $ctl->done();
}

sub cmd_help {
    my $ctl = shift;

    $ctl->ok();
    foreach my $cmd (sort keys %cmd_docs){
	my $descr = $cmd_docs{$cmd}{descr} || 'undocumented';
	$ctl->write("$cmd\t$descr\n");
    }
    $ctl->write("\n");
}

sub cmd_console {
    my $ctl = shift;
    my $param = shift;
    
    $ctl->ok_n();
    push @consoles, $ctl
	unless( $ctl->{type} =~ /console/ );
    $ctl->{type} = "Cconsole";
}

sub cmd_hup {
    my $ctl = shift;

    $ctl->ok_n();
    ::loggit( 'restart requested - HUPing', 1 );
    kill 'HUP', $$;
}

sub cmd_shutdown {
    my $ctl = shift;
    my $param = shift;

    $ctl->ok_n();
    ::loggit( "shutting down - $param->{reason}", 1 )
	if $param->{reason};
    
    if( $$ == $::mainpid ){
	# keep things happy
	::loggit( 'shutdown requested - exiting', 1 );
	$::exitinprogress = 1;
	exit(0);
    }
    kill 'TERM', $::mainpid;
}

################################################################

command_install( 'echo',     \&cmd_echo,     "returns its input", "*" );
command_install( 'bye',      \&cmd_byebye,   "disconnect" );
command_install( 'help',     \&cmd_help,     "no help at all" );
command_install( 'console',  \&cmd_console,  "turn on console mode--session will get copies of log msgs" );
command_install( 'hup',      \&cmd_hup,      "restart the server" );
command_install( 'shutdown', \&cmd_shutdown, "shutdown the server" );

1;

 
